Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4841)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4842)
@@ -3,7 +3,7 @@
 ! This file is part of PALM-4U.
 !
-! PALM-4U is free software: you can redistribute it and/or modify it under the 
-! terms of the GNU General Public License as published by the Free Software 
-! Foundation, either version 3 of the License, or (at your option) any later 
+! PALM-4U is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
 ! version.
 !
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! reading of namelist file and actions in case of namelist errors revised so that statement labels
+! and goto statements are not required any more
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Bugfix in obtaining the correct timestamp in case of restart runs
 !
@@ -39,43 +43,43 @@
 ! 4671 2020-09-09 20:27:58Z pavelkrc
 ! Implementation of downward facing USM and LSM surfaces
-! 
+!
 ! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
-! 
+!
 ! 4527 2020-05-11 09:39:55Z monakurppa
 ! Correct a bug in salsa_wrd_global and salsa_check_data_output,
 ! and add reglim to be read/written in the restart data
-! 
+!
 ! 4525 2020-05-10 17:05:07Z raasch
 ! added reading/writing of global restart data,
 ! added reading/writing restart data with MPI-IO,
 ! variable write_binary_salsa removed
-! 
+!
 ! 4512 2020-04-30 12:55:34Z monakurppa
 ! Fixed a bug in component_index_constructor: index out of bounds if all chemical
 ! components are used
-! 
+!
 ! 4508 2020-04-24 13:32:20Z raasch
 ! decycling replaced by explicit setting of lateral boundary conditions (Siggi)
-! 
+!
 ! 4487 2020-04-03 09:38:20Z raasch
 ! bugfix for subroutine calls that contain the decycle_salsa switches as arguments
-! 
+!
 ! 4481 2020-03-31 18:55:54Z maronga
 ! Bug fix to the previous commit: the logical switch monotonic_limiter_z missing
 ! from advec_s_ws in salsa_tendency_ij
-! 
+!
 ! 4478 2020-03-27 14:06:23Z monakurppa
 ! Bug fixes:
 ! - call salsa_driver in salsa_init also for the ghost points
 ! - decycle flags missing from advec_s_ws call in salsa_tendency
-! 
+!
 ! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
-! 
+!
 ! 4442 2020-03-04 19:21:13Z suehring
-! Change order of dimension in surface array %frac to allow for better 
+! Change order of dimension in surface array %frac to allow for better
 ! vectorization.
-! 
+!
 ! 4441 2020-03-04 19:20:35Z suehring
 ! Bug fixes and reformatting for the restart data and averaged data output
@@ -86,8 +90,8 @@
 !   chemical components: set to 4d arrays instead of separate arrays
 ! - add allocation checks for averaged data output arrays
-! 
+!
 ! 4416 2020-02-20 17:53:57Z monakurppa
 ! Time index error in salsa_emission_setup
-! 
+!
 ! 4380 2020-01-17 23:39:51Z monakurppa
 ! - Error in saving the surface fluxes in an array that is applied in the
@@ -95,32 +99,32 @@
 ! - Corrections in the header: aerosol bin diameters and lower bin limits not
 !   printed correctly
-! 
+!
 ! 4364 2020-01-08 02:12:31Z monakurppa
 ! Set time coordinate in the input data relative to origin_time rather than to
 ! 00:00:00 UTC
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
-! 
+!
 ! 4342 2019-12-16 13:49:14Z Giersch
 ! cdc replaced by canopy_drag_coeff
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4315 2019-12-02 09:20:07Z monakurppa
 ! Add an additional check for the time dimension PIDS_SALSA in
 ! salsa_emission_setup and correct some error message identifiers.
-! 
+!
 ! 4298 2019-11-21 15:59:16Z suehring
 ! Bugfix, close netcdf input files after reading
-! 
+!
 ! 4295 2019-11-14 06:15:31Z monakurppa
-! 
-! 
+!
+!
 ! 4280 2019-10-29 14:34:15Z monakurppa
 ! Corrected a bug in boundary conditions and fac_dt in offline nesting
-! 
+!
 ! 4273 2019-10-24 13:40:54Z monakurppa
 ! - Rename nest_salsa to nesting_salsa
@@ -129,5 +133,5 @@
 !   chemistry module is applied
 ! - Set the default value of nesting_salsa and nesting_offline_salsa to .TRUE.
-! 
+!
 ! 4272 2019-10-23 15:18:57Z schwenkel
 ! Further modularization of boundary conditions: moved boundary conditions to
@@ -144,24 +148,24 @@
 ! - Reformat salsa emission data with LOD=2: size distribution given for each
 !   emission category
-! 
+!
 ! 4268 2019-10-17 11:29:38Z schwenkel
 ! Moving module specific boundary conditions from time_integration to module
-! 
+!
 ! 4256 2019-10-07 10:08:52Z monakurppa
 ! Document previous changes: use global variables nx, ny and nz in salsa_header
-! 
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
-! 
+!
 ! 4226 2019-09-10 17:03:24Z suehring
 ! Netcdf input routine for dimension length renamed
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4167 2019-08-16 11:01:48Z suehring
-! Changed behaviour of masked output over surface to follow terrain and ignore 
+! Changed behaviour of masked output over surface to follow terrain and ignore
 ! buildings (J.Resler, T.Gronemeier)
-! 
+!
 ! 4131 2019-08-02 11:06:18Z monakurppa
 ! - Add "salsa_" before each salsa output variable
@@ -174,5 +178,5 @@
 ! - Add the z-dimension for gaseous emissions to correspond the implementation
 !   in the chemistry module
-! 
+!
 ! 4118 2019-07-25 16:11:45Z suehring
 ! - When Dirichlet condition is applied in decycling, the boundary conditions are
@@ -189,25 +193,25 @@
 !   This is done to overcome high concentration peaks due to stationary numerical
 !   oscillations caused by horizontal advection discretization.
-! 
+!
 ! 4117 2019-07-25 08:54:02Z monakurppa
-! Pass integer flag array as well as boundary flags to WS scalar advection 
+! Pass integer flag array as well as boundary flags to WS scalar advection
 ! routine
-! 
+!
 ! 4109 2019-07-22 17:00:34Z suehring
-! Slightly revise setting of boundary conditions at horizontal walls, use 
+! Slightly revise setting of boundary conditions at horizontal walls, use
 ! data-structure offset index instead of pre-calculate it for each facing
-! 
+!
 ! 4079 2019-07-09 18:04:41Z suehring
-! Application of monotonic flux limiter for the vertical scalar advection 
-! up to the topography top (only for the cache-optimized version at the 
+! Application of monotonic flux limiter for the vertical scalar advection
+! up to the topography top (only for the cache-optimized version at the
 ! moment).
-! 
+!
 ! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to 
+! Masked output running index mid has been introduced as a local variable to
 ! avoid runtime error (Loop variable has been modified) in time_integration
-! 
+!
 ! 4058 2019-06-27 15:25:42Z knoop
 ! Bugfix: to_be_resorted was uninitialized in case of s_H2O in 3d_data_averaging
-! 
+!
 ! 4012 2019-05-31 15:19:05Z monakurppa
 ! Merge salsa branch to trunk. List of changes:
@@ -221,5 +225,5 @@
 ! - stuff from salsa_util_mod.f90 moved into salsa_mod.f90
 ! - calls for closing the netcdf input files added
-! 
+!
 ! 3956 2019-05-07 12:32:52Z monakurppa
 ! - Conceptual bug in depo_surf correct for urban and land surface model
@@ -229,8 +233,8 @@
 !   salsa_exchange_horiz_bounds after calling salsa_driver only when needed
 !   (i.e. every dt_salsa).
-! 
+!
 ! 3924 2019-04-23 09:33:06Z monakurppa
 ! Correct a bug introduced by the previous update.
-! 
+!
 ! 3899 2019-04-16 14:05:27Z monakurppa
 ! - remove unnecessary error / location messages
@@ -239,10 +243,10 @@
 !
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
+! Changes related to global restructuring of location messages and introduction
 ! of additional debug messages
-! 
+!
 ! 3876 2019-04-08 18:41:49Z knoop
 ! Introduced salsa_actions module interface
-! 
+!
 ! 3871 2019-04-08 14:38:39Z knoop
 ! Major changes in formatting, performance and data input structure (see branch
@@ -255,5 +259,5 @@
 !   surface_aerosol_flux, aerosol_flux_dpg/sigmag/mass_fracs_a/mass_fracs_b.
 ! - All emissions are now implemented as surface fluxes! No 3D sources anymore.
-! - Update the emission information by calling salsa_emission_update if 
+! - Update the emission information by calling salsa_emission_update if
 !   skip_time_do_salsa >= time_since_reference_point and
 !   next_aero_emission_update <= time_since_reference_point
@@ -280,17 +284,17 @@
 ! - Removed tailing white spaces and unused variables
 ! - Change error message to start by PA instead of SA
-! 
+!
 ! 3833 2019-03-28 15:04:04Z forkel
-! added USE chem_gasphase_mod for nvar, nspec and spc_names 
-! 
+! added USE chem_gasphase_mod for nvar, nspec and spc_names
+!
 ! 3787 2019-03-07 08:43:54Z raasch
 ! unused variables removed
-! 
+!
 ! 3780 2019-03-05 11:19:45Z forkel
 ! unused variable for file index removed from rrd-subroutines parameter list
-! 
+!
 ! 3685 2019-01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Implementation of the PALM module interface
@@ -438,6 +442,6 @@
         (/0.0,   0.056, 0.0,   0.056, 0.056, 0.042, 0.056, -99., 0.042,0.014,0.056, -99., -99., -99., 0.056/)
 !
-!-- Constants for the dry deposition model by Zhang et al. (2001): 
-!-- empirical constants "alpha" and "gamma" and characteristic radius "A" for 
+!-- Constants for the dry deposition model by Zhang et al. (2001):
+!-- empirical constants "alpha" and "gamma" and characteristic radius "A" for
 !-- each land use category (15) and season (5)
     REAL(wp), DIMENSION(1:15), PARAMETER :: alpha_z01 = &
@@ -445,5 +449,5 @@
     REAL(wp), DIMENSION(1:15), PARAMETER :: gamma_z01 = &
         (/0.56, 0.58, 0.56, 0.56, 0.56, 0.54, 0.54, 0.54, 0.54, 0.54, 0.54, 0.54, 0.50, 0.50, 0.56/)
-    REAL(wp), DIMENSION(1:15,1:5), PARAMETER :: A_z01 =  RESHAPE( (/& 
+    REAL(wp), DIMENSION(1:15,1:5), PARAMETER :: A_z01 =  RESHAPE( (/&
          2.0, 5.0, 2.0,  5.0, 5.0, 2.0, 2.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC1
          2.0, 5.0, 2.0,  5.0, 5.0, 2.0, 2.0, -99., -99., 10.0, 10.0, -99., -99., -99., 10.0,&  ! SC2
@@ -1113,9 +1117,9 @@
  CONTAINS
 
-!------------------------------------------------------------------------------!
+!-------------------  -----------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Parin for &salsa_par for new modules
-!------------------------------------------------------------------------------!
+!---------------------                    ---------------------------------------------------------!
  SUBROUTINE salsa_parin
 
@@ -1125,80 +1129,88 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=80) ::  line   !< dummy string that contains the current line of parameter file
+    CHARACTER(LEN=100) ::  line   !< dummy string that contains the current line of parameter file
 
     INTEGER(iwp) ::  i                 !< loop index
+    INTEGER(iwp) ::  io_status         !< status after reading the namelist file
     INTEGER(iwp) ::  max_pr_salsa_tmp  !< dummy variable
 
-    NAMELIST /salsa_parameters/      aerosol_flux_dpg,                         &
-                                     aerosol_flux_mass_fracs_a,                &
-                                     aerosol_flux_mass_fracs_b,                &
-                                     aerosol_flux_sigmag,                      &
-                                     advect_particle_water,                    &
-                                     bc_aer_b,                                 &
-                                     bc_aer_l,                                 &
-                                     bc_aer_n,                                 &
-                                     bc_aer_r,                                 &
-                                     bc_aer_s,                                 &
-                                     bc_aer_t,                                 &
-                                     depo_pcm_par,                             &
-                                     depo_pcm_type,                            &
-                                     depo_surf_par,                            &
-                                     dpg,                                      &
-                                     dt_salsa,                                 &
-                                     emiss_factor_main,                        &
-                                     emiss_factor_side,                        &
-                                     feedback_to_palm,                         &
-                                     h2so4_init,                               &
-                                     hno3_init,                                &
-                                     listspec,                                 &
-                                     main_street_id,                           &
-                                     mass_fracs_a,                             &
-                                     mass_fracs_b,                             &
-                                     max_street_id,                            &
-                                     n_lognorm,                                &
-                                     nbin,                                     &
-                                     nesting_salsa,                            &
-                                     nesting_offline_salsa,                    &
-                                     nf2a,                                     &
-                                     nh3_init,                                 &
-                                     nj3,                                      &
-                                     nlcnd,                                    &
-                                     nlcndgas,                                 &
-                                     nlcndh2oae,                               &
-                                     nlcoag,                                   &
-                                     nldepo,                                   &
-                                     nldepo_pcm,                               &
-                                     nldepo_surf,                              &
-                                     nldistupdate,                             &
-                                     nsnucl,                                   &
-                                     ocnv_init,                                &
-                                     ocsv_init,                                &
-                                     reglim,                                   &
-                                     salsa,                                    &
-                                     salsa_emission_mode,                      &
-                                     season_z01,                               &
-                                     sigmag,                                   &
-                                     side_street_id,                           &
-                                     skip_time_do_salsa,                       &
-                                     surface_aerosol_flux,                     &
+    NAMELIST /salsa_parameters/      aerosol_flux_dpg,                                             &
+                                     aerosol_flux_mass_fracs_a,                                    &
+                                     aerosol_flux_mass_fracs_b,                                    &
+                                     aerosol_flux_sigmag,                                          &
+                                     advect_particle_water,                                        &
+                                     bc_aer_b,                                                     &
+                                     bc_aer_l,                                                     &
+                                     bc_aer_n,                                                     &
+                                     bc_aer_r,                                                     &
+                                     bc_aer_s,                                                     &
+                                     bc_aer_t,                                                     &
+                                     depo_pcm_par,                                                 &
+                                     depo_pcm_type,                                                &
+                                     depo_surf_par,                                                &
+                                     dpg,                                                          &
+                                     dt_salsa,                                                     &
+                                     emiss_factor_main,                                            &
+                                     emiss_factor_side,                                            &
+                                     feedback_to_palm,                                             &
+                                     h2so4_init,                                                   &
+                                     hno3_init,                                                    &
+                                     listspec,                                                     &
+                                     main_street_id,                                               &
+                                     mass_fracs_a,                                                 &
+                                     mass_fracs_b,                                                 &
+                                     max_street_id,                                                &
+                                     n_lognorm,                                                    &
+                                     nbin,                                                         &
+                                     nesting_salsa,                                                &
+                                     nesting_offline_salsa,                                        &
+                                     nf2a,                                                         &
+                                     nh3_init,                                                     &
+                                     nj3,                                                          &
+                                     nlcnd,                                                        &
+                                     nlcndgas,                                                     &
+                                     nlcndh2oae,                                                   &
+                                     nlcoag,                                                       &
+                                     nldepo,                                                       &
+                                     nldepo_pcm,                                                   &
+                                     nldepo_surf,                                                  &
+                                     nldistupdate,                                                 &
+                                     nsnucl,                                                       &
+                                     ocnv_init,                                                    &
+                                     ocsv_init,                                                    &
+                                     reglim,                                                       &
+                                     salsa,                                                        &
+                                     salsa_emission_mode,                                          &
+                                     season_z01,                                                   &
+                                     sigmag,                                                       &
+                                     side_street_id,                                               &
+                                     skip_time_do_salsa,                                           &
+                                     surface_aerosol_flux,                                         &
                                      van_der_waals_coagc
 
-    line = ' '
-!
-!-- Try to find salsa package
-    REWIND ( 11 )
-    line = ' '
-    DO WHILE ( INDEX( line, '&salsa_parameters' ) == 0 )
-       READ ( 11, '(A)', END=10 )  line
-    ENDDO
-    BACKSPACE ( 11 )
-!
-!-- Read user-defined namelist
-    READ ( 11, salsa_parameters )
-!
-!-- Enable salsa (salsa switch in modules.f90)
-    salsa = .TRUE.
-
- 10 CONTINUE
+
+!
+!-- Move to the beginning of the namelist file and try to find and read the namelist.
+    REWIND( 11 )
+    READ( 11, salsa_parameters, IOSTAT=io_status )
+
+!
+!-- Action depending on the READ status
+    IF ( io_status == 0 )  THEN
+!
+!--    salsa_parameters namelist was found and read correctly. Enable salsa (salsa switch in
+!--    modules.f90)
+       salsa = .TRUE.
+
+    ELSEIF ( io_status > 0 )  THEN
+!
+!--    salsa_parameters namelist was found but contained errors. Print an error message including
+!--    the line that caused the problem.
+       BACKSPACE( 11 )
+       READ( 11 , '(A)' ) line
+       CALL parin_fail_message( 'salsa_parameters', line )
+
+    ENDIF
+
 !
 !-- Update the number of output profiles
@@ -1212,4 +1224,5 @@
 
  END SUBROUTINE salsa_parin
+
 
 !------------------------------------------------------------------------------!
@@ -1445,5 +1458,5 @@
 
     IMPLICIT NONE
- 
+
     INTEGER(iwp), INTENT(IN) ::  io   !< Unit of the output file
 !
@@ -1748,5 +1761,5 @@
 !-- (number concentration (#/m3) )
 !
-!-- If chemistry is on, read gas phase concentrations from there. Otherwise, 
+!-- If chemistry is on, read gas phase concentrations from there. Otherwise,
 !-- allocate salsa_gas array.
 
@@ -1822,5 +1835,5 @@
        ENDDO
 !
-!--    Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and 
+!--    Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and
 !--    westward (l=3) facing
        DO  l = 0, 3
@@ -1999,6 +2012,6 @@
 ! Description:
 ! ------------
-!> Initializes particle size distribution grid by calculating size bin limits 
-!> and mid-size for *dry* particles in each bin. Called from salsa_initialize 
+!> Initializes particle size distribution grid by calculating size bin limits
+!> and mid-size for *dry* particles in each bin. Called from salsa_initialize
 !> (only at the beginning of simulation).
 !> Size distribution described using:
@@ -2009,7 +2022,7 @@
 !> based on given subrange size limits and bin number.
 !
-!> Mona changed 06/2017: Use geometric mean diameter to describe the mean 
+!> Mona changed 06/2017: Use geometric mean diameter to describe the mean
 !> particle diameter in a size bin, not the arithmeric mean which clearly
-!> overestimates the total particle volume concentration. 
+!> overestimates the total particle volume concentration.
 !
 !> Coded by:
@@ -2089,5 +2102,5 @@
 !> Initilize altitude-dependent aerosol size distributions and compositions.
 !>
-!> Mona added 06/2017: Correct the number and mass concentrations by normalizing 
+!> Mona added 06/2017: Correct the number and mass concentrations by normalizing
 !< by the given total number and mass concentration.
 !>
@@ -2268,5 +2281,5 @@
              CALL get_variable( id_dyn, 'Dmid', pr_dmid )
 !
-!--          Check whether the sectional representation conform to the one 
+!--          Check whether the sectional representation conform to the one
 !--          applied in the model
              IF ( ANY( ABS( ( aero(1:nbins_aerosol)%dmid - pr_dmid ) /                             &
@@ -2323,5 +2336,5 @@
              message_string = 'Error in initialising mass fractions of chemical components. ' //   &
                               'Check that all chemical components are included in parameter file!'
-             CALL message( 'salsa_mod: aerosol_init', 'PA0606', 2, 2, 0, 6, 0 ) 
+             CALL message( 'salsa_mod: aerosol_init', 'PA0606', 2, 2, 0, 6, 0 )
           ENDIF
 !
@@ -2550,5 +2563,5 @@
                    ENDIF
                    ib = ib+1
-                ENDDO 
+                ENDDO
              ENDIF
           ENDDO !< k
@@ -2593,5 +2606,5 @@
 ! Description:
 ! ------------
-!> Create a lognormal size distribution and discretise to a sectional 
+!> Create a lognormal size distribution and discretise to a sectional
 !> representation.
 !------------------------------------------------------------------------------!
@@ -2687,5 +2700,5 @@
 !
 !--          Predetermine flag to mask topography
-             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) ) 
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 !
 !--          Regime 2a:
@@ -2717,5 +2730,5 @@
                    IF ( prunmode == 1 )  THEN
                       aerosol_mass(ic)%init(k) = MAX( 0.0_wp, pmf2b(k) ) * ( 1.0_wp - pnf2a(k) ) * &
-                                                 pndist(k,ib) * pcore(ib) * prho 
+                                                 pndist(k,ib) * pcore(ib) * prho
                    ENDIF
                    ib = ib + 1
@@ -3630,9 +3643,9 @@
 ! Description:
 ! ------------
-!> Performs necessary unit and dimension conversion between the host model and 
+!> Performs necessary unit and dimension conversion between the host model and
 !> SALSA module, and calls the main SALSA routine.
 !> Partially adobted form the original SALSA boxmodel version.
 !> Now takes masses in as kg/kg from LES!! Converted to m3/m3 for SALSA
-!> 05/2016 Juha: This routine is still pretty much in its original shape. 
+!> 05/2016 Juha: This routine is still pretty much in its original shape.
 !>               It's dumb as a mule and twice as ugly, so implementation of
 !>               an improved solution is necessary sooner or later.
@@ -3752,5 +3765,5 @@
 !
 !--    Set volume concentrations:
-!--    Sulphate (SO4) or sulphuric acid H2SO4 
+!--    Sulphate (SO4) or sulphuric acid H2SO4
        IF ( index_so4 > 0 )  THEN
           vc = 1
@@ -3820,5 +3833,5 @@
        IF ( index_no > 0 )  THEN
           vc = 6
-          str = ( index_no-1 ) * nbins_aerosol + 1 
+          str = ( index_no-1 ) * nbins_aerosol + 1
           endi = index_no * nbins_aerosol
           ic = 1
@@ -3859,5 +3872,5 @@
        aero_old(1:nbins_aerosol)%volc(vc) = lo_aero(1:nbins_aerosol)%volc(vc)
 !
-!--    Number concentrations (numc) and particle sizes 
+!--    Number concentrations (numc) and particle sizes
 !--    (dwet = wet diameter, core = dry volume)
        DO  ib = 1, nbins_aerosol
@@ -4114,5 +4127,5 @@
 !
 !-- Set surfaces and wall fluxes due to deposition
-    IF ( lsdepo  .AND.  lsdepo_surf  .AND.  prunmode == 3 )  THEN 
+    IF ( lsdepo  .AND.  lsdepo_surf  .AND.  prunmode == 3 )  THEN
        IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
           CALL depo_surf( i, j, surf_def_h(0), vd, schmidt_num, kvis, in_u, .TRUE. )
@@ -4189,12 +4202,12 @@
 
  END SUBROUTINE set_salsa_runtime
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculates the absolute temperature (using hydrostatic pressure), saturation 
-!> vapour pressure and mixing ratio over water, relative humidity and air 
+!> Calculates the absolute temperature (using hydrostatic pressure), saturation
+!> vapour pressure and mixing ratio over water, relative humidity and air
 !> density needed in the SALSA model.
-!> NOTE, no saturation adjustment takes place -> the resulting water vapour 
+!> NOTE, no saturation adjustment takes place -> the resulting water vapour
 !> mixing ratio can be supersaturated, allowing the microphysical calculations
 !> in SALSA.
@@ -4254,5 +4267,5 @@
 ! Description:
 ! ------------
-!> Calculates ambient sizes of particles by equilibrating soluble fraction of 
+!> Calculates ambient sizes of particles by equilibrating soluble fraction of
 !> particles with water using the ZSR method (Stokes and Robinson, 1966).
 !> Method:
@@ -4260,21 +4273,21 @@
 !> - (ammonium) sulphate (100%)
 !> - sea salt (100 %)
-!> - organic carbon (epsoc * 100%) 
+!> - organic carbon (epsoc * 100%)
 !> Exact thermodynamic considerations neglected.
-!> - If particles contain no sea salt, calculation according to sulphate 
+!> - If particles contain no sea salt, calculation according to sulphate
 !>   properties
-!> - If contain sea salt but no sulphate, calculation according to sea salt 
+!> - If contain sea salt but no sulphate, calculation according to sea salt
 !>   properties
-!> - If contain both sulphate and sea salt -> the molar fraction of these 
+!> - If contain both sulphate and sea salt -> the molar fraction of these
 !>   compounds determines which one of them is used as the basis of calculation.
-!> If sulphate and sea salt coexist in a particle, it is assumed that the Cl is 
-!> replaced by sulphate; thus only either sulphate + organics or sea salt + 
+!> If sulphate and sea salt coexist in a particle, it is assumed that the Cl is
+!> replaced by sulphate; thus only either sulphate + organics or sea salt +
 !> organics is included in the calculation of soluble fraction.
-!> Molality parameterizations taken from Table 1 of Tang: Thermodynamic and 
-!> optical properties of mixed-salt aerosols of atmospheric importance, 
+!> Molality parameterizations taken from Table 1 of Tang: Thermodynamic and
+!> optical properties of mixed-salt aerosols of atmospheric importance,
 !> J. Geophys. Res., 102 (D2), 1883-1893 (1997)
 !
 !> Coded by:
-!> Hannele Korhonen (FMI) 2005 
+!> Hannele Korhonen (FMI) 2005
 !> Harri Kokkola (FMI) 2006
 !> Matti Niskanen(FMI) 2012
@@ -4282,5 +4295,5 @@
 !> Modified for the new aerosol datatype, Juha Tonttila (FMI) 2014
 !
-!> fxm: should sea salt form a solid particle when prh is very low (even though 
+!> fxm: should sea salt form a solid particle when prh is very low (even though
 !> it could be mixed with e.g. sulphate)?
 !> fxm: crashes if no sulphate or sea salt
@@ -4335,5 +4348,5 @@
           zvpart(6:7) = paero(ib)%volc(6:7) / paero(ib)%numc
 !
-!--       Total volume and wet diameter of one dry particle 
+!--       Total volume and wet diameter of one dry particle
           zcore = SUM( zvpart(1:2) )
           zdwet = paero(ib)%dwet
@@ -4345,5 +4358,5 @@
              zaw = MAX( 1.0E-3_wp, zrh / zke ) ! To avoid underflow
 !
-!--          Binary molalities (mol/kg): 
+!--          Binary molalities (mol/kg):
 !--          Sulphate
              zbinmol(1) = 1.1065495E+2_wp - 3.6759197E+2_wp * zaw + 5.0462934E+2_wp * zaw**2 -     &
